package ntut.edu.curtain;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;

public class ProtocolImpl implements Protocol {
    
    byte[] buffer = new byte[1024];
    int tail = 0;
   
    public void onReceive(byte b) {
        // simple protocol: each message ends with new line
        if (b=='\n') {
            onMessage();
        } else {
   
            buffer[tail] = b;
            tail++;
        }
    }
 
    public void onStreamClosed() {
        onMessage();
    }
    
    private void sendMsg2WebService(String message) {
		HttpURLConnection conn = null;
    	try {
    	URL url = new URL("http://localhost:8080/CurtainServer/Message/saveMsg?msg="+ message);
    	System.out.println(message);
//		Log.i("LoginActivity", "......................"+ url);
		conn = (HttpURLConnection) url.openConnection();
//		conn.setReadTimeout(10000);
//		conn.setConnectTimeout(15000);
		conn.setRequestMethod("GET");
		conn.connect();
		
		// 讀取資料
					BufferedReader reader = new BufferedReader(new InputStreamReader(
							conn.getInputStream(), "UTF-8"));
					
					
					System.out.println(reader.readLine());
					
					reader.close();
    	} catch (Exception e) {
			e.printStackTrace();
		} finally {
			if (conn != null) {
				conn.disconnect();
			}
		}
	}
   
    /*
     * When message is recognized onMessage is invoked
     */
    private void onMessage() {
        if (tail!=0) {
            // constructing message
            String message = getMessage(buffer, tail);
            System.out.println("RECEIVED MESSAGE: " + message);
           
            //TODO
            sendMsg2WebService(message);
            
            // this logic should be placed in some kind of
            // message interpreter class not here
            //if ("HELO".equals(message)) {
            //    CommPortSender.send(getMessage("OK"));
            //} else if ("OK".equals(message)) {
            //    CommPortSender.send(getMessage("OK ACK"));
            //}
            tail = 0;
        }
    }
   
    // helper methods
    public byte[] getMessage(String message) {
        return (message+"\n").getBytes();
    }
   
    public String getMessage(byte[] buffer, int len) {
        return new String(buffer, 0, tail);
    }
}

